#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MIN(x, y) ( (x)<(y) ? (x) : (y) )
#define MAX(x, y) ( (x)>(y) ? (x) : (y) )
   
/*
void main(void)
{
	int  n1, n2, n12, n ;
	double  getprob( int, int, int, int, double) ;
	double r ;
	
	
	while( 1){
		printf (" n n1 n2 n12 r?\n");
		scanf("%d %d %d %d %lf",&n, &n1, &n2, &n12, &r);
		printf(" %e\n", getprob(n, n1, n2, n12, r) ) ;
		}
		


}
*/

struct dipdata {
	int n;
	double d12 ;
	int ad; 
	int ndip[6][6] ;
	}  ;


struct hapdata {
        int n;
        int n00;
        int n01;
        int n10;
        int n11;
        int n0q;
        int n1q;
        int nq0;
        int nq1;
        int nqq;
        double d12 ;
        int ad;
        }  ;   

double
getprobmsconddip( struct dipdata dv,  double c, int nsites, double *recrates, double ****prob, double *ppoly )
{
	int n00, n01, n10, n11, n00_0q, n01_0q, n10_1q, n11_1q, n00_q0, n10_q0,
		n01_q1, n11_q1, n00_qq, n10_qq, n01_qq, n11_qq, n1dot, ndot1 ;
	double sum , pr, coef, lncoef , x ;
	float bico(int, int), factln( int) ;
	int hvtotal, n , nhet ;
	double co1, co2, co3, co4, r ;
	double getprobmscond( struct hapdata, double, int, double *, double ****, double *) ;
	struct hapdata hv ;
	int i, j;
	int n00s, n01s, n10s, n11s , n0qs, n1qs, nq0s, nq1s, nqqs, nc, n00_13, n11_14, n00_31, n11_41, 
            n00_33, n11_44, n01_34, n10_43 ;
	int nhapnoms, nhaprms, nhapelms, ndipnoms , ntemp ;

/* printf(" getprob:  %d %d %d %d %d %d %lf %d\n", hv.n, hv.n00, hv.n01, hv.n10, hv.n11, hv.n0q, hv.d12, hv.ad);
*/
	n = dv.n ;
	hv.n = n ;
	hv.d12 = dv.d12 ;
	hv.ad = dv.ad ;
	n00s = 2*dv.ndip[0][0] + dv.ndip[0][1] + dv.ndip[0][3] + dv.ndip[1][0] + dv.ndip[3][0] ;
	n01s = 2*dv.ndip[0][2] + dv.ndip[0][1] + dv.ndip[0][4] + dv.ndip[1][2] + dv.ndip[3][2] ;
	n10s = 2*dv.ndip[2][0] + dv.ndip[1][0] + dv.ndip[4][0] + dv.ndip[2][1] + dv.ndip[2][3] ;
	n11s = 2*dv.ndip[2][2] + dv.ndip[1][2] + dv.ndip[2][4] + dv.ndip[2][1] + dv.ndip[4][2] ;
	n0qs = 2*dv.ndip[0][5] + dv.ndip[0][3] + dv.ndip[0][4] + dv.ndip[1][5] + dv.ndip[3][5] ;
	n1qs = 2*dv.ndip[2][5] + dv.ndip[1][5] + dv.ndip[2][3] + dv.ndip[2][4] + dv.ndip[4][5] ;
	nq0s = 2*dv.ndip[5][0] + dv.ndip[5][1] + dv.ndip[5][3] + dv.ndip[3][0] + dv.ndip[4][0] ;
	nq1s = 2*dv.ndip[5][2] + dv.ndip[5][1] + dv.ndip[5][4] + dv.ndip[3][2] + dv.ndip[4][2] ;
	nqqs = 2*dv.ndip[5][5] + dv.ndip[5][3] + dv.ndip[5][4] + dv.ndip[3][5] + dv.ndip[4][5] ;

	sum = 0.  ;

	for( nc = 0 ; nc <= dv.ndip[1][1] ; nc++){
	for( n00_13 = 0 ; n00_13 <= dv.ndip[1][3] ; n00_13++){
	for( n11_14 = 0 ; n11_14 <= dv.ndip[1][4] ; n11_14++){
	for( n00_31 = 0 ; n00_31 <= dv.ndip[3][1] ; n00_31++){
	for( n11_41 = 0 ; n11_41 <= dv.ndip[4][1] ; n11_41++){
	for( n00_33 = 0 ; n00_33 <= dv.ndip[3][3] ; n00_33++){
	for( n11_44 = 0 ; n11_44 <= dv.ndip[4][4] ; n11_44++){
	for( n01_34 = 0 ; n01_34 <= dv.ndip[3][4] ; n01_34++){
	for( n10_43 = 0 ; n10_43 <= dv.ndip[4][3] ; n10_43++){
	 hv.n00 = n00s + nc + n00_13 + n00_31 + n00_33 ;
	 hv.n01 = n01s + (dv.ndip[1][1] -nc)  + (dv.ndip[3][1] - n00_31) + ( dv.ndip[1][4] - n11_14) + n01_34  ;
	hv.n10 = n10s + (dv.ndip[1][1] -nc) + (dv.ndip[1][3] - n00_13) + (dv.ndip[4][1] - n11_41) + n10_43 ; 
	 hv.n11 = n11s + nc + n11_14 + n11_41 + n11_44   ;
	hv.n0q = n0qs + (dv.ndip[1][3]-n00_13) + n11_14 + (dv.ndip[3][3] - n00_33) + (dv.ndip[3][4] - n01_34) ; 
	hv.n1q = n1qs + n00_13 + (dv.ndip[1][4] - n11_14) + (dv.ndip[4][4] - n11_44) + (dv.ndip[4][3] - n10_43)  ; 
	hv.nq0 = nq0s + (dv.ndip[3][1] - n00_31) + n11_41 + (dv.ndip[3][3] - n00_33) + (dv.ndip[4][3] - n10_43) ;
	hv.nq1 = nq1s + n00_31 + (dv.ndip[4][1] - n11_41 ) + (dv.ndip[3][4] - n01_34) + (dv.ndip[4][4] - n11_44) ;  
	hv.nqq = nqqs +  n00_33 + n01_34 + n11_44 + n10_43 ; 

	lncoef = 0.0 ;
	nhet = dv.ndip[0][1] + dv.ndip[1][0] + dv.ndip[1][1] + dv.ndip[1][2] + dv.ndip[1][5] 
		 + dv.ndip[2][1] + dv.ndip[5][1];
	lncoef += nhet*log(2.0) ;
	nhapnoms = hv.n00 + hv.n01 + hv.n10 + hv.n11 ;
	lncoef +=  -factln(nhapnoms) + factln( hv.n00) + factln( hv.n01) + factln( hv.n10) + factln( hv.n11) ;
	nhaprms = hv.n0q + hv.n1q ;
	nhapelms = hv.nq0 + hv.nq1 ;
	lncoef += -factln( nhaprms ) + factln( hv.n0q ) + factln( hv.n1q) ;
	lncoef += -factln( nhapelms ) + factln( hv.nq0 ) + factln( hv.nq1 ) ;
	ndipnoms =  dv.ndip[0][0] + dv.ndip[0][1] + dv.ndip[0][2] + dv.ndip[1][0] + dv.ndip[1][1] +
		dv.ndip[1][2] + dv.ndip[2][2] ;
	lncoef += factln( ndipnoms ) - factln( dv.ndip[0][0]) - factln( dv.ndip[0][1] ) - factln( dv.ndip[0][2]) 
	    - factln( dv.ndip[1][0] ) - factln( dv.ndip[1][1]-nc ) - factln( nc) -  factln( dv.ndip[1][2]) -
	  -factln( dv.ndip[2][0] ) -factln( dv.ndip[2][1] ) - factln( dv.ndip[2][2] )  ;
	ntemp = dv.ndip[0][3] + dv.ndip[0][4] + dv.ndip[1][3] + dv.ndip[1][4] + dv.ndip[2][3] + dv.ndip[2][4] ;
	lncoef += factln( ntemp) - factln( dv.ndip[0][3] ) - factln( dv.ndip[0][4] ) - factln( dv.ndip[2][3] ) -
		   factln( dv.ndip[2][4] ) - factln( n00_13 ) - factln( dv.ndip[1][3] - n00_13) -
	          factln( n11_14 ) - factln( dv.ndip[1][4] - n11_14 ) ;
	ntemp = dv.ndip[3][0] + dv.ndip[4][0] + dv.ndip[3][1] + dv.ndip[4][3] + dv.ndip[3][2] + dv.ndip[4][2] ;
	lncoef += factln( ntemp) - factln( dv.ndip[3][0] ) - factln( dv.ndip[4][0] ) - factln( dv.ndip[3][2] ) -
		   factln( dv.ndip[4][2] ) - factln( n00_31 ) - factln( dv.ndip[3][1] - n00_31) -
	          factln( n11_41 ) - factln( dv.ndip[4][1] - n11_41 ) ;
	ntemp = n00_33 + n11_44 + n01_34 + n10_43 ;
	lncoef +=  factln( ntemp) - factln( n00_33) - factln( n11_44) - factln( n01_34 ) - factln( n10_43 ) ;
	ntemp = dv.ndip[3][3] + dv.ndip[4][4] + dv.ndip[3][4] + dv.ndip[4][3] - ntemp ;
	lncoef += factln( ntemp) - factln( dv.ndip[3][3] - n00_33) - factln( dv.ndip[4][4] - n11_44) -
		  factln( dv.ndip[3][4] - n01_34) - factln( dv.ndip[4][3] - n10_43 ) ;
	ntemp = dv.ndip[5][0] + dv.ndip[5][1] + dv.ndip[5][2] ;
	lncoef += factln( ntemp) - factln( dv.ndip[5][0] ) - factln( dv.ndip[5][1] ) - factln( dv.ndip[5][2] )  ;
	ntemp = dv.ndip[0][5] + dv.ndip[1][5] + dv.ndip[2][5] ;
	lncoef += factln( ntemp) - factln( dv.ndip[0][5] ) - factln( dv.ndip[1][5] ) - factln( dv.ndip[2][5] )  ;
  	lncoef += factln( dv.ndip[3][5] + dv.ndip[4][5] ) - factln( dv.ndip[3][5] ) - factln( dv.ndip[4][5] ) ;	
  	lncoef += factln( dv.ndip[5][3] + dv.ndip[5][4] ) - factln( dv.ndip[5][3] ) - factln( dv.ndip[5][4] ) ;	

	coef = exp( lncoef ) ;
	  pr = getprobmscond( hv, c, nsites, recrates, prob, ppoly  )  ;
	  sum += pr*coef  ;
	} }  } } } } } } }

	return( sum  ) ;
}
 

/*
float bico(n,k)
int k,n;
{
	float factln();

	return floor(0.5+exp(factln(n)-factln(k)-factln(n-k)));
}

float factln(n)
int n;
{
	float gammln();
	void nrerror();
	static float a[101];

	if (n < 0){
		fprintf(stderr," Negative factorial in routine factln\n");
		exit(0);
	       }
	if (n <= 1) return 0.0;
	if (n <= 100) return a[n] ? a[n] : (a[n]=gammln(n+1.0));
	else return gammln(n+1.0);
}

float gammln(xx)
float xx;
{
	double x,y,tmp,ser;
	static double cof[6]={76.18009172947146,-86.50532032941677,
		24.01409824083091,-1.231739572450155,
		0.1208650973866179e-2,-0.5395239384953e-5};
	int j;

	y=x=xx;
	tmp=x+5.5;
	tmp -= (x+0.5)*log(tmp);
	ser=1.000000000190015;
	for (j=0;j<=5;j++) ser += cof[j]/++y;
	return -tmp+log(2.5066282746310005*ser/x);
}
*/
